
import java.applet.Applet;
import java.awt.*;

public class Stack extends Applet
{

    public Stack()
    {
        myButton1 = new Button("SEND ONE PACKET");
        myButton2 = new Button("CLEAR");
    }

    public String getAppletInfo()
    {
        return "Name: BAKSHU & BATCH";
    }

    public void init()
    {
        setBackground(Color.lightGray);
        xFactor = 7;
        yFactor = 4;
        resize(xFactor * 100, yFactor * 100);
        add(myButton1);
        add(myButton2);
    }

    public void destroy()
    {
    }

    public void paint(Graphics g)
    {
        g.drawString("PACKET TRAVERSAL OF THE PROTOCOL STACK LAYERS", xFactor * 24, yFactor * 110);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 5, yFactor * 15, xFactor * 20, yFactor * 10);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 5, yFactor * 30, xFactor * 20, yFactor * 10);
        g.setColor(Color.yellow);
        g.fillRect(xFactor * 5, yFactor * 45, xFactor * 20, yFactor * 10);
        g.setColor(Color.green);
        g.fillRect(xFactor * 5, yFactor * 60, xFactor * 20, yFactor * 10);
        g.setColor(Color.pink);
        g.fillRect(xFactor * 5, yFactor * 75, xFactor * 20, yFactor * 10);
        g.setColor(Color.yellow);
        g.fillRect(xFactor * 35, yFactor * 45, xFactor * 20, yFactor * 10);
        g.setColor(Color.green);
        g.fillRect(xFactor * 35, yFactor * 60, xFactor * 20, yFactor * 10);
        g.setColor(Color.pink);
        g.fillRect(xFactor * 35, yFactor * 75, xFactor * 20, yFactor * 10);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 65, yFactor * 15, xFactor * 20, yFactor * 10);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 65, yFactor * 30, xFactor * 20, yFactor * 10);
        g.setColor(Color.yellow);
        g.fillRect(xFactor * 65, yFactor * 45, xFactor * 20, yFactor * 10);
        g.setColor(Color.green);
        g.fillRect(xFactor * 65, yFactor * 60, xFactor * 20, yFactor * 10);
        g.setColor(Color.pink);
        g.fillRect(xFactor * 65, yFactor * 75, xFactor * 20, yFactor * 10);
        g.setColor(Color.black);
        g.drawString("APPLICATION", xFactor * 10, yFactor * 21);
        g.drawString("APPLICATION", xFactor * 70, yFactor * 21);
        g.drawString("TRANSPORT", xFactor * 11, yFactor * 36);
        g.drawString("TRANSPORT", xFactor * 71, yFactor * 36);
        g.drawString("NETWORK", xFactor * 12, yFactor * 51);
        g.drawString("NETWORK", xFactor * 42, yFactor * 51);
        g.drawString("NETWORK", xFactor * 72, yFactor * 51);
        g.drawString("DATA LINK", xFactor * 10, yFactor * 66);
        g.drawString("DATA LINK", xFactor * 40, yFactor * 66);
        g.drawString("DATA LINK", xFactor * 70, yFactor * 66);
        g.drawString("PHYSICAL", xFactor * 12, yFactor * 81);
        g.drawString("PHYSICAL", xFactor * 42, yFactor * 81);
        g.drawString("PHYSICAL", xFactor * 72, yFactor * 81);
        g.drawString("Network 1", xFactor * 23, yFactor * 93);
        g.drawString("Network 2", xFactor * 58, yFactor * 93);
        g.drawString("SOURCE HOST", xFactor * 10, yFactor * 97);
        g.drawString("INTERMEDIATE ROUTER", xFactor * 35, yFactor * 97);
        g.drawString("DESTINATION HOST", xFactor * 67, yFactor * 97);
        g.drawLine(xFactor * 15, yFactor * 25, xFactor * 15, yFactor * 30);
        g.drawLine(xFactor * 15, yFactor * 40, xFactor * 15, yFactor * 45);
        g.drawLine(xFactor * 15, yFactor * 55, xFactor * 15, yFactor * 60);
        g.drawLine(xFactor * 15, yFactor * 70, xFactor * 15, yFactor * 75);
        g.drawLine(xFactor * 15, yFactor * 85, xFactor * 15, yFactor * 90);
        g.drawLine(xFactor * 40, yFactor * 55, xFactor * 40, yFactor * 60);
        g.drawLine(xFactor * 40, yFactor * 70, xFactor * 40, yFactor * 75);
        g.drawLine(xFactor * 40, yFactor * 85, xFactor * 40, yFactor * 90);
        g.drawLine(xFactor * 50, yFactor * 55, xFactor * 50, yFactor * 60);
        g.drawLine(xFactor * 50, yFactor * 70, xFactor * 50, yFactor * 75);
        g.drawLine(xFactor * 50, yFactor * 85, xFactor * 50, yFactor * 90);
        g.drawLine(xFactor * 75, yFactor * 25, xFactor * 75, yFactor * 30);
        g.drawLine(xFactor * 75, yFactor * 40, xFactor * 75, yFactor * 45);
        g.drawLine(xFactor * 75, yFactor * 55, xFactor * 75, yFactor * 60);
        g.drawLine(xFactor * 75, yFactor * 70, xFactor * 75, yFactor * 75);
        g.drawLine(xFactor * 75, yFactor * 85, xFactor * 75, yFactor * 90);
        g.drawLine(xFactor * 15, yFactor * 90, xFactor * 40, yFactor * 90);
        g.drawLine(xFactor * 50, yFactor * 90, xFactor * 75, yFactor * 90);
        g.drawLine(xFactor * 15, yFactor * 30, xFactor * 16, yFactor * 29);
        g.drawLine(xFactor * 15, yFactor * 30, xFactor * 14, yFactor * 29);
        g.drawLine(xFactor * 15, yFactor * 45, xFactor * 16, yFactor * 44);
        g.drawLine(xFactor * 15, yFactor * 45, xFactor * 14, yFactor * 44);
        g.drawLine(xFactor * 15, yFactor * 60, xFactor * 16, yFactor * 59);
        g.drawLine(xFactor * 15, yFactor * 60, xFactor * 14, yFactor * 59);
        g.drawLine(xFactor * 15, yFactor * 75, xFactor * 16, yFactor * 74);
        g.drawLine(xFactor * 15, yFactor * 75, xFactor * 14, yFactor * 74);
        g.drawLine(xFactor * 40, yFactor * 85, xFactor * 41, yFactor * 86);
        g.drawLine(xFactor * 40, yFactor * 85, xFactor * 39, yFactor * 86);
        g.drawLine(xFactor * 40, yFactor * 70, xFactor * 41, yFactor * 71);
        g.drawLine(xFactor * 40, yFactor * 70, xFactor * 39, yFactor * 71);
        g.drawLine(xFactor * 40, yFactor * 55, xFactor * 41, yFactor * 56);
        g.drawLine(xFactor * 40, yFactor * 55, xFactor * 39, yFactor * 56);
        g.drawLine(xFactor * 50, yFactor * 60, xFactor * 51, yFactor * 59);
        g.drawLine(xFactor * 50, yFactor * 60, xFactor * 49, yFactor * 59);
        g.drawLine(xFactor * 50, yFactor * 75, xFactor * 51, yFactor * 74);
        g.drawLine(xFactor * 50, yFactor * 75, xFactor * 49, yFactor * 74);
        g.drawLine(xFactor * 75, yFactor * 85, xFactor * 76, yFactor * 86);
        g.drawLine(xFactor * 75, yFactor * 85, xFactor * 74, yFactor * 86);
        g.drawLine(xFactor * 75, yFactor * 70, xFactor * 76, yFactor * 71);
        g.drawLine(xFactor * 75, yFactor * 70, xFactor * 74, yFactor * 71);
        g.drawLine(xFactor * 75, yFactor * 55, xFactor * 76, yFactor * 56);
        g.drawLine(xFactor * 75, yFactor * 55, xFactor * 74, yFactor * 56);
        g.drawLine(xFactor * 75, yFactor * 40, xFactor * 76, yFactor * 41);
        g.drawLine(xFactor * 75, yFactor * 40, xFactor * 74, yFactor * 41);
        g.drawLine(xFactor * 75, yFactor * 25, xFactor * 76, yFactor * 26);
        g.drawLine(xFactor * 75, yFactor * 25, xFactor * 74, yFactor * 26);
    }

    public void drawSquares(Graphics g)
    {

        g.setColor(Color.black);
        g.fillRect(xFactor * 23, yFactor * 11, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 23, yFactor * 26, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 21, yFactor * 26, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 23, yFactor * 41, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 21, yFactor * 41, xFactor * 2, yFactor * 2);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 19, yFactor * 41, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 23, yFactor * 56, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 21, yFactor * 56, xFactor * 2, yFactor * 2);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 19, yFactor * 56, xFactor * 2, yFactor * 2);
        g.setColor(Color.yellow);
        g.fillRect(xFactor * 17, yFactor * 56, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 23, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 21, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 19, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.yellow);
        g.fillRect(xFactor * 17, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.green);
        g.fillRect(xFactor * 15, yFactor * 71, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 23, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 21, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 19, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.yellow);
        g.fillRect(xFactor * 17, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.green);
        g.fillRect(xFactor * 15, yFactor * 86, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 36, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 34, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 32, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.yellow);
        g.fillRect(xFactor * 30, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.green);
        g.fillRect(xFactor * 28, yFactor * 86, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 36, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 34, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 32, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.yellow);
        g.fillRect(xFactor * 30, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.green);
        g.fillRect(xFactor * 28, yFactor * 71, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 36, yFactor * 56, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 34, yFactor * 56, xFactor * 2, yFactor * 2);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 32, yFactor * 56, xFactor * 2, yFactor * 2);
        g.setColor(Color.yellow);
        g.fillRect(xFactor * 30, yFactor * 56, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 58, yFactor * 56, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 56, yFactor * 56, xFactor * 2, yFactor * 2);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 54, yFactor * 56, xFactor * 2, yFactor * 2);
        g.setColor(Color.yellow);
        g.fillRect(xFactor * 52, yFactor * 56, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 58, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 56, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 54, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.yellow);
        g.fillRect(xFactor * 52, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.green);
        g.fillRect(xFactor * 50, yFactor * 71, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 58, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 56, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 54, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.yellow);
        g.fillRect(xFactor * 52, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.green);
        g.fillRect(xFactor * 50, yFactor * 86, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 71, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 69, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 67, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.yellow);
        g.fillRect(xFactor * 65, yFactor * 86, xFactor * 2, yFactor * 2);
        g.setColor(Color.green);
        g.fillRect(xFactor * 63, yFactor * 86, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 71, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 69, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 67, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.yellow);
        g.fillRect(xFactor * 65, yFactor * 71, xFactor * 2, yFactor * 2);
        g.setColor(Color.green);
        g.fillRect(xFactor * 63, yFactor * 71, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 69, yFactor * 56, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 67, yFactor * 56, xFactor * 2, yFactor * 2);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 65, yFactor * 56, xFactor * 2, yFactor * 2);
        g.setColor(Color.yellow);
        g.fillRect(xFactor * 63, yFactor * 56, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 67, yFactor * 41, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 65, yFactor * 41, xFactor * 2, yFactor * 2);
        g.setColor(Color.cyan);
        g.fillRect(xFactor * 63, yFactor * 41, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 65, yFactor * 26, xFactor * 2, yFactor * 2);
        g.setColor(Color.orange);
        g.fillRect(xFactor * 63, yFactor * 26, xFactor * 2, yFactor * 2);
        pause();
        g.setColor(Color.black);
        g.fillRect(xFactor * 65, yFactor * 11, xFactor * 2, yFactor * 2);
        pause();
    }

    private void pause()
    {
        try
        {
            Thread.currentThread();
            Thread.sleep(400L);
            return;
        }
        catch(InterruptedException _ex)
        {
            return;
        }
    }

    public void clearSquares(Graphics g)
    {
        g.setColor(getBackground());

        g.fillRect(xFactor * 23, yFactor * 11, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 23, yFactor * 26, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 21, yFactor * 26, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 23, yFactor * 41, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 21, yFactor * 41, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 19, yFactor * 41, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 23, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 21, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 19, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 17, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 23, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 21, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 19, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 17, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 15, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 23, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 21, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 19, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 17, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 15, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 36, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 34, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 32, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 30, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 28, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 36, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 34, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 32, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 30, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 28, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 36, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 34, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 32, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 30, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 58, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 56, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 54, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 52, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 58, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 56, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 54, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 52, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 50, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 58, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 56, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 54, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 52, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 50, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 71, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 69, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 67, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 65, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 63, yFactor * 86, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 71, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 69, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 67, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 65, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 63, yFactor * 71, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 69, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 67, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 65, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 63, yFactor * 56, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 67, yFactor * 41, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 65, yFactor * 41, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 63, yFactor * 41, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 65, yFactor * 26, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 63, yFactor * 26, xFactor * 2, yFactor * 2);
        g.fillRect(xFactor * 65, yFactor * 11, xFactor * 2, yFactor * 2);
 

    }

    public void start()
    {
    }

    public void stop()
    {
    }

    public boolean action(Event event, Object obj)
    {
        Graphics g = getGraphics();
        if(event.target instanceof Button)
            if(obj.equals("SEND ONE PACKET"))
                drawSquares(g);
            else
            if(obj.equals("CLEAR"))
                clearSquares(g);
        return true;
    }

    Button myButton1;
    Button myButton2;
    int yFactor;
    int xFactor;
}
