
/*
   FLOW CONTROL

*/

import java.applet.Applet;
import java.awt.*;
import java.util.Random;

public class TCP3 extends Applet
    implements Runnable
{

    public void init()
    {
        setBackground(Color.lightGray);
        setLayout(new GridLayout(4, 1, 7, 0));
        panel1 = new Panel();
        add(panel1);
        send_buff = new Choice();
        send_buff.addItem("2 Kbytes");
        send_buff.addItem("4 Kbytes");
        send_buff.addItem("6 Kbytes");
        send_buff.addItem("8 Kbytes");
        send_label = new Label();
        send_label.setText("Buffer Size ");
        send_data_size = new Choice();
        send_data_size.addItem("4 Kbytes");
        send_data_size.addItem("8 Kbytes");
        send_data_size.addItem("16 Kbytes");
        send_size = new Label();
        send_size.setText("File size");
        rec_label = new Label();
        rec_label.setText("Receive Buffer Size  :");
        Start = new Button("Start");
        Pause = new Button("Stop");
        Resume = new Button("Resume");
        Reset = new Button("Reset");
        panel1.setLayout(new GridLayout(3, 5, 10, 10));
        panel1.add(Start);
        panel1.add(Pause);
        panel1.add(Resume);
        panel1.add(Reset);
        panel1.add(send_size);
        panel1.add(send_data_size);
        panel1.add(new Label(""));
        panel1.add(new Label(""));
        panel1.add(send_label);
        panel1.add(send_buff);
        panel1.add(new Label(""));
        panel1.add(new Label(""));
        validate();
    }

    public void paint(Graphics g)
    {
        Dimension dimension = size();
        int i = dimension.width;
        int j = dimension.height;
        g.setColor(Color.lightGray);
        g.fillRect(0, 0, i, j);
        g.setColor(Color.white);
        g.fillRect(10, 150, 100, 120);
        g.fillRect(390, 150, 100, 120);
        g.setColor(Color.black);
        g.drawRect(10, 150, 100, 120);
        g.drawRect(11, 151, 98, 118);
        g.drawRect(12, 152, 96, 116);
        g.drawRect(390, 150, 100, 120);
        g.drawRect(391, 151, 98, 118);
        g.drawRect(392, 152, 96, 116);
        g.setColor(Color.black);
        g.drawString("Host A", 20, 145);
        g.drawString("Host B", 400, 145);
        if(init_draw)
        {
            g.setColor(Color.white);
            g.fillRect(10, 280, 100, 30);
            g.fillRect(390, 280, 100, 30);
            g.setColor(Color.black);
            g.drawString("Send Buffer", 10, 330);
            g.drawString("Receive Buffer", 380, 330);
            g.drawRect(10, 280, 100, 30);
            g.drawRect(11, 281, 98, 28);
            g.drawRect(12, 282, 96, 26);
            g.drawRect(390, 280, 100, 30);
            g.drawRect(391, 281, 98, 28);
            g.drawRect(392, 282, 96, 26);
            g.fillRect(110, 290, 280, 2);
            g.fillRect(110, 300, 280, 2);
            g.setColor(Color.white);
            g.fillRect(110, 292, 280, 8);
            return;
        }
        g.setColor(Color.white);
        g.fillRect(10, 280, SBBlockSize * SBBlockNum, 30);
        g.fillRect(390, 280, RBBlockSize * RBBlockNum, 30);
        g.setColor(Color.blue);
        g.fillRect(10, 280, (int)(((double)send_buffer / 2D) * (double)SBBlockSize), 30);
        g.fillRect(390, 280, (int)(((double)receive_buffer / 2D) * (double)RBBlockSize), 30);
        g.setColor(Color.black);
        g.drawString("Send Buffer : " + send_buff_size + "K", 10, 330);
        g.drawString("Rcv Buffer Size : " + Swindow_size + "K", 10, 350);
        g.drawString("Receive Buffer : " + receive_buff_size + "K", 380, 330);
        g.setColor(Color.black);
        g.drawRect(9, 279, SBBlockSize * SBBlockNum, 30);
        g.drawRect(8, 278, SBBlockSize * SBBlockNum + 2, 32);
        g.drawRect(389, 279, RBBlockSize * RBBlockNum, 30);
        g.drawRect(388, 278, RBBlockSize * RBBlockNum + 2, 32);
        g.setColor(Color.black);
        g.fillRect(12 + SBBlockSize * SBBlockNum, 290, 378 - SBBlockSize * SBBlockNum, 2);
        g.fillRect(12 + SBBlockSize * SBBlockNum, 300, 378 - SBBlockSize * SBBlockNum, 2);
        g.setColor(Color.black);
        g.drawRect(70, 160, 31, 97);
        g.setColor(Color.blue);
        g.fillRect(71, Px, 30, Pheight);
        g.drawString(send_data + "K", 45, Px + 6);
        g.setColor(Color.black);
        g.drawRect(450, 160, 31, 97);
        g.setColor(Color.blue);
        g.fillRect(451, Cx, 30, Cheight);
        g.drawString(consumed_data + "K", 425, Cx + 6);
        if(send_anim)
        {
            g.setColor(Color.white);
            g.fillRect(155, 240, 200, 40);
            g.setColor(Color.black);
            g.drawRect(150, 240, 100, 40);
            g.drawRect(151, 241, 98, 38);
            g.drawRect(250, 240, 100, 40);
            g.drawRect(251, 241, 98, 38);
            if(send_amount == 0)
                Rsend_amount = 1;
            else
                Rsend_amount = send_amount * 1024;
            g.drawString("      " + Rsend_amount + " byte", 160, 265);
            g.drawString("  SEQ = " + (seq - send_amount) * 1024, 260, 265);
            g.setColor(Color.blue);
            g.fillRect(px, 292, 20, 8);
        }
        if(ack_anim)
        {
            g.setColor(Color.white);
            g.fillRect(155, 310, 200, 40);
            g.setColor(Color.black);
            g.drawRect(150, 310, 100, 40);
            g.drawRect(151, 311, 98, 38);
            g.drawRect(250, 310, 100, 40);
            g.drawRect(251, 311, 98, 38);
            g.drawString("  ACK = " + ack * 1024, 160, 335);
            g.drawString("  WIN = " + Awindow_size * 1024, 260, 335);
            g.setColor(Color.red);
            g.fillRect(qx, 292, 20, 8);
        }
        if(consume)
        {
            g.setColor(Color.red);
            g.drawString("Data Consumed", 255, 190);
            g.drawString("by Consumer", 255, 210);
        }
    }

    public boolean action(Event event, Object obj)
    {
        if(event.target == Start)
        {
            data_size = 4 * Exp(send_data_size.getSelectedIndex());
            send_data = data_size;
            send_buff_size = (send_buff.getSelectedIndex() + 1) * 2;
            receive_buff_size = send_buff_size;
            send_buffer = 0;
            receive_buffer = 0;
            Swindow_size = receive_buff_size;
            Rwindow_size = Swindow_size;
            Awindow_size = Rwindow_size;
            receive_data = 0;
            consumed_data = 0;
            Sbuffer_left = 0;
            seq = 0;
            ack = 0;
            px = sEnd;
            qx = rEnd;
            PBlockSize = 96 / data_size;
            CBlockSize = PBlockSize;
            if(send_buff_size >= 6 || receive_buff_size >= 6)
            {
                SBBlockSize = 25;
                RBBlockSize = 25;
            } else
            {
                SBBlockSize = 50;
                RBBlockSize = 50;
            }
            SBBlockNum = send_buff_size / 2;
            RBBlockNum = receive_buff_size / 2;
            sStart = 12 + SBBlockSize * SBBlockNum;
            sEnd = 370;
            rStart = sEnd;
            rEnd = sStart;
            Px = 161;
            Cx = 257;
            Pheight = 96;
            Cheight = 0;
            get_ack = false;
            get_free_ack = false;
            data_send = false;
            ack_send = false;
            free_ack_send = false;
            seq_changed = false;
            buffer_empty = true;
            window_size_used = false;
            init_draw = false;
            send_anim = false;
            ack_anim = false;
            consume = false;
            repaint();
            producer_on_process = true;
            sender_on_process = true;
            receiver_on_process = true;
            consumer_on_process = true;
            Producer.resume();
            for(int i = 0; i < 1000; i++);
            Receiver.resume();
            Consumer.resume();
            Sender.resume();
            return true;
        }
        if(event.target == Pause)
        {
            Producer.suspend();
            Sender.suspend();
            Receiver.suspend();
            Consumer.suspend();
            return true;
        }
        if(event.target == Resume)
        {
            Producer.resume();
            Sender.resume();
            Receiver.resume();
            Consumer.resume();
            return true;
        }
        if(event.target == Reset)
        {
            Producer.suspend();
            Sender.suspend();
            Receiver.suspend();
            Consumer.suspend();
            if(sFor || rFor)
                reset = true;
            send_data_size.select(0);
            send_buff.select(0);
            producer_on_process = false;
            sender_on_process = false;
            receiver_on_process = false;
            consumer_on_process = false;
            init_draw = true;
            repaint();
            return true;
        } else
        {
            return false;
        }
    }

    public void start()
    {
        Producer = new Thread(this, "Producer");
        Sender = new Thread(this, "Sender");
        Receiver = new Thread(this, "Receiver");
        Consumer = new Thread(this, "Consumer");
        Producer.start();
        Sender.start();
        Receiver.start();
        Consumer.start();
    }

    public void stop()
    {
        Producer.stop();
        Sender.stop();
        Receiver.stop();
        Consumer.stop();
        Producer = null;
        Sender = null;
        Receiver = null;
        Consumer = null;
    }

    public void run()
    {
        Dimension dimension = size();
        if(offscreen == null || imagewidth != dimension.width || imageheight != dimension.height)
            offscreen = createImage(dimension.width, dimension.height);
        imagewidth = dimension.width;
        imageheight = dimension.height;
        clipR = new Rectangle(10, 280, 580, 30);
        Rectangle rectangle = new Rectangle(200, 220, 200, 140);
        clipR = clipR.union(rectangle);
        if(Thread.currentThread() == Producer)
        {
            Producer_Process();
            return;
        }
        if(Thread.currentThread() == Sender)
        {
            Sender_Process();
            return;
        }
        if(Thread.currentThread() == Receiver)
        {
            Receiver_Process();
            return;
        }
        if(Thread.currentThread() == Consumer)
            Consumer_Process();
    }

    public void Producer_Process()
    {
        do
        {
            try
            {
                Thread.sleep(10L);
            }
            catch(InterruptedException _ex) { }
            while(producer_on_process) 
                if(send_data == 0)
                {
                    producer_on_process = false;
                } else
                {
                    try
                    {
                        if(send_data == data_size)
                        {
                            Thread.sleep(300L);
                            Thread.sleep(300L);
                            Thread.sleep(300L);
                            Thread.sleep(300L);
                        }
                    }
                    catch(InterruptedException _ex) { }
                    FillBuffer();
                }
        } while(true);
    }

    public synchronized void FillBuffer()
    {
        try
        {
            while(!buffer_empty) 
                wait();
        }
        catch(InterruptedException _ex) { }
        if(send_data >= send_buff_size)
        {
            send_buffer = send_buff_size;
            notify();
            send_data -= send_buffer;
            notify();
        } else
        {
            send_buffer = send_data;
            notify();
            send_data = 0;
            notify();
        }
        buffer_empty = false;
        Px = 161 + PBlockSize * (data_size - send_data);
        Pheight = PBlockSize * send_data;
        repaint();
        try
        {
            Thread.sleep(100L);
            Thread.sleep(100L);
            Thread.sleep(100L);
            Thread.sleep(100L);
            return;
        }
        catch(InterruptedException _ex)
        {
            return;
        }
    }

    public void Sender_Process()
    {
        boolean flag = false;
        do
        {
            try
            {
                Thread.sleep(20L);
            }
            catch(InterruptedException _ex) { }
            while(sender_on_process) 
                if(data_size == seq)
                {
                    sender_on_process = false;
                    boolean flag1 = true;
                } else
                {
                    sending();
                    if(skip)
                        skip = false;
                    else
                        wait_for_ack();
                }
        } while(true);
    }

    public synchronized void sending()
    {
        try
        {
            while(send_buffer == 0) 
                wait();
        }
        catch(InterruptedException _ex) { }
        change_seq();
        send_anim = true;
        synchronized(Painting)
        {
            sFor = true;
            for(px = sStart; px < sEnd; px += 2)
            {
                Graphics g = offscreen.getGraphics();
                g.clipRect(clipR.x, clipR.y, clipR.width, clipR.height);
                paint(g);
                g = getGraphics();
                g.clipRect(clipR.x, clipR.y, clipR.width, clipR.height);
                g.drawImage(offscreen, 0, 0, this);
                try
                {
                    Thread.sleep(10L);
                }
                catch(InterruptedException _ex) { }
            }

            sFor = false;
        }
        if(reset)
        {
            reset = false;
            skip = true;
            return;
        }
        send_anim = false;
        synchronized(Painting)
        {
            Sbuffer_left = send_buffer;
            Graphics g1 = offscreen.getGraphics();
            g1.clipRect(clipR.x, clipR.y, clipR.width, clipR.height);
            paint(g1);
            g1 = getGraphics();
            g1.clipRect(clipR.x, clipR.y, clipR.width, clipR.height);
            g1.drawImage(offscreen, 0, 0, this);
        }
        try
        {
            Thread.sleep(100L);
        }
        catch(InterruptedException _ex) { }
        data_send = true;
        notifyAll();
        if(send_buffer == 0)
        {
            buffer_empty = true;
            notifyAll();
        }
    }

    public synchronized void change_seq()
    {
        if(Swindow_size == 0)
            send_amount = 0;
        else
        if(send_buffer < Swindow_size)
        {
            send_amount = send_buffer;
            send_buffer = 0;
            notifyAll();
        } else
        {
            send_amount = Swindow_size;
            send_buffer -= Swindow_size;
            notifyAll();
        }
        seq += send_amount;
        seq_changed = true;
        notifyAll();
        window_size_used = true;
        notifyAll();
    }

    public synchronized void wait_for_ack()
    {
        try
        {
            while(!get_ack) 
                wait();
            Swindow_size = Awindow_size;
            repaint();
            get_ack = false;
            notifyAll();
            ack_send = false;
            notifyAll();
            return;
        }
        catch(InterruptedException _ex)
        {
            return;
        }
    }

    public synchronized void wait_for_free_win()
    {
        try
        {
            while(!get_free_ack) 
                wait();
            Swindow_size = Awindow_size;
            repaint();
            get_free_ack = false;
            notifyAll();
            free_ack_send = false;
            notifyAll();
            return;
        }
        catch(InterruptedException _ex)
        {
            return;
        }
    }

    public void Receiver_Process()
    {
        do
        {
            try
            {
                Thread.sleep(20L);
            }
            catch(InterruptedException _ex) { }
            while(receiver_on_process) 
                if(!consumer_on_process)
                {
                    receiver_on_process = false;
                } else
                {
                    receiving();
                    send_ack();
                }
        } while(true);
    }

    public synchronized void receiving()
    {
        try
        {
            while(!data_send) 
                wait();
            int i = read_seq();
            data_send = false;
            receive_buffer += receive_amount;
            synchronized(Painting)
            {
                Graphics g = offscreen.getGraphics();
                g.clipRect(clipR.x, clipR.y, clipR.width, clipR.height);
                paint(g);
                g = getGraphics();
                g.clipRect(clipR.x, clipR.y, clipR.width, clipR.height);
                g.drawImage(offscreen, 0, 0, this);
            }
            Rwindow_size -= receive_amount;
            return;
        }
        catch(InterruptedException _ex)
        {
            return;
        }
    }

    public synchronized int read_seq()
    {
        try
        {
            while(!seq_changed) 
                wait();
            seq_changed = false;
            receive_amount = send_amount;
        }
        catch(InterruptedException _ex) { }
        return seq;
    }

    public synchronized void send_ack()
    {
        Awindow_size = Rwindow_size;
        ack += receive_amount;
        ack_anim = true;
        synchronized(Painting)
        {
            for(qx = rStart; qx > rEnd; qx -= 2)
            {
                Graphics g1 = offscreen.getGraphics();
                g1.clipRect(clipR.x, clipR.y, clipR.width, clipR.height);
                paint(g1);
                g1 = getGraphics();
                g1.clipRect(clipR.x, clipR.y, clipR.width, clipR.height);
                g1.drawImage(offscreen, 0, 0, this);
                try
                {
                    Thread.sleep(10L);
                }
                catch(InterruptedException _ex) { }
            }

        }
        ack_anim = false;
        Graphics g = offscreen.getGraphics();
        g.clipRect(clipR.x, clipR.y, clipR.width, clipR.height);
        paint(g);
        g = getGraphics();
        g.clipRect(clipR.x, clipR.y, clipR.width, clipR.height);
        g.drawImage(offscreen, 0, 0, this);
        try
        {
            Thread.sleep(100L);
        }
        catch(InterruptedException _ex) { }
        get_ack = true;
        notifyAll();
        ack_send = true;
    }

    public synchronized void send_free_ack()
    {
        try
        {
            while(Rwindow_size == 0) 
                wait();
            Awindow_size = Rwindow_size;
            ack_anim = true;
            synchronized(Painting)
            {
                for(qx = rStart; qx > rEnd; qx -= 2)
                {
                    Graphics g = offscreen.getGraphics();
                    g.clipRect(clipR.x, clipR.y, clipR.width, clipR.height);
                    paint(g);
                    g = getGraphics();
                    g.clipRect(clipR.x, clipR.y, clipR.width, clipR.height);
                    g.drawImage(offscreen, 0, 0, this);
                    try
                    {
                        Thread.sleep(5L);
                    }
                    catch(InterruptedException _ex) { }
                }

            }
            ack_anim = false;
            repaint();
            get_free_ack = true;
            notifyAll();
            free_ack_send = true;
            return;
        }
        catch(InterruptedException _ex)
        {
            return;
        }
    }

    public void Consumer_Process()
    {
        Random random = new Random();
        do
        {
            try
            {
                Thread.sleep(20L);
            }
            catch(InterruptedException _ex) { }
            while(consumer_on_process) 
                if(consumed_data == data_size)
                {
                    consumer_on_process = false;
                } else
                {
                    try
                    {
                        int i = (int)(random.nextFloat() * 100F);
                        Thread.sleep(i * i * 2);
                    }
                    catch(InterruptedException _ex) { }
                    if(receive_buffer > 1)
                    {
                        consume = true;
                        Graphics g = offscreen.getGraphics();
                        Rectangle rectangle = new Rectangle(280, 180, 210, 60);
                        rectangle = rectangle.union(clipR);
                        g.clipRect(rectangle.x, rectangle.y, rectangle.width, rectangle.height);
                        paint(g);
                        g = getGraphics();
                        g.clipRect(rectangle.x, rectangle.y, rectangle.width, rectangle.height);
                        g.drawImage(offscreen, 0, 0, this);
                        try
                        {
                            Producer.suspend();
                            Sender.suspend();
                            Receiver.suspend();
                            Thread.sleep(2000L);
                            Producer.resume();
                            Sender.resume();
                            Receiver.resume();
                        }
                        catch(InterruptedException _ex) { }
                        consume = false;
                        consumed_data += 2;
                        receive_buffer -= 2;
                        Cx = 257 - CBlockSize * consumed_data;
                        Cheight = CBlockSize * consumed_data;
                        repaint();
                        if(receive_buffer == receive_buff_size - 2)
                            free_buffer();
                        else
                            inc_winSize();
                    }
                }
        } while(true);
    }

    public void inc_winSize()
    {
        ack_send = false;
        Rwindow_size = receive_buffer;
    }

    public synchronized void free_buffer()
    {
        free_ack_send = false;
        Rwindow_size = 2;
    }

    public int Exp(int i)
    {
        int k = 1;
        if(i == 0)
            return k;
        for(int j = 0; j < i; j++)
            k *= 2;

        return k;
    }

    public TCP3()
    {
        data_send = false;
        ack_send = false;
        free_ack_send = false;
        seq_changed = false;
        window_size_used = false;
        sFor = false;
        rFor = false;
        reset = false;
        skip = false;
        init_draw = true;
        start_anim = false;
        buffer_empty = true;
        Painting = new Object();
        Win = new Object();
    }

    private Thread Producer;
    private Thread Sender;
    private Thread Receiver;
    private Thread Consumer;
    private Label send_size;
    private Choice send_data_size;
    private Choice send_buff;
    private Choice rec_buff;
    private Label send_label;
    private Label rec_label;
    private Button Start;
    private Button Pause;
    private Button Resume;
    private Button Reset;
    private Panel panel1;
    private boolean producer_on_process;
    private boolean sender_on_process;
    private boolean receiver_on_process;
    private boolean consumer_on_process;
    private boolean get_ack;
    private boolean get_free_ack;
    private boolean data_send;
    private boolean ack_send;
    private boolean free_ack_send;
    private boolean seq_changed;
    private boolean window_size_used;
    private boolean sFor;
    private boolean rFor;
    private boolean reset;
    private boolean skip;
    private int data_size;
    private int send_data;
    private int receive_data;
    private int consumed_data;
    private int send_buff_size;
    private int receive_buff_size;
    private int send_buffer;
    private int receive_buffer;
    private int Swindow_size;
    private int Rwindow_size;
    private int Awindow_size;
    private int ack;
    private int seq;
    private int send_amount;
    private int receive_amount;
    private int Rsend_amount;
    private boolean init_draw;
    private boolean start_anim;
    private boolean send_anim;
    private boolean ack_anim;
    private boolean consume;
    private boolean buffer_empty;
    private Object Painting;
    private Object Win;
    private int PBlockSize;
    private int CBlockSize;
    private int SBBlockSize;
    private int RBBlockSize;
    private int SBBlockNum;
    private int RBBlockNum;
    private int sStart;
    private int sEnd;
    private int rStart;
    private int rEnd;
    private int px;
    private int py;
    private int qx;
    private int qy;
    private int Px;
    private int Cx;
    private int Pheight;
    private int Cheight;
    private int Sbuffer_left;
    public static final int FullSize = 96;
    Image offscreen;
    int imagewidth;
    int imageheight;
    Rectangle clipR;
}


//<applet  code=TCP3.class width=600 height=600></applet>
