/*
SMTP APPLET

*/


import java.applet.Applet;
import java.util.*;
import java.awt.*;

public class smtp extends Applet
{

    public smtp()
    {
        connected = false;
        painted = false;
        serverVisible = false;
        clientVisible = false;
    }

    public String getAppletInfo()
    {
        return "Name: ALLA BASKHU & BATCH\n";
    }

    public void init()
    {
        setLayout(null);
        width = bounds().width;
        height = bounds().height;
        heightU = height / 20;
        widthU = width / 20;
        addresses = 0;
        connected = false;
        reply = 2;
        cmd = 0;
        log = new TextArea(5, 40);
        log.reshape(width / 2 - 8 * widthU, height - 5 * heightU, 16 * widthU, 5 * heightU);
        log.setEditable(false);
        add(log);
        logLabel = new Label("Connection Log", 0);
        logLabel.reshape(width / 2 - 8 * widthU, height - 6 * heightU, 16 * widthU, heightU);
        add(logLabel);
        clientText = new TextField(64);
        clientText.reshape(widthU, 2 * heightU, 7 * widthU, heightU);
        clientText.disable();
        clientText.setEditable(false);
        clientText.hide();
        add(clientText);
        clientSend = new Button("Send");
        clientSend.hide();
        clientSend.reshape(widthU, 3 * heightU, 2 * widthU, heightU);
        add(clientSend);
        clientLabel = new Label("Sender", 0);
        clientLabel.reshape(widthU, heightU, 7 * widthU, heightU);
        clientLabel.hide();
        add(clientLabel);
        usersLabel = new Label("Users:BAKSHU,GANGA,NAGAIAH,VENKAT", 0);
        usersLabel.reshape(width - 8 * widthU, heightU * 2, 7 * widthU, heightU);
        usersLabel.hide();
        add(usersLabel);
        mailMsg = new TextArea(64, 5);
        mailMsg.reshape(width - 8 * widthU, 4 * heightU, 7 * widthU, heightU * 5);
        mailMsg.setEditable(false);
        mailMsg.hide();
        add(mailMsg);
        serverLabel = new Label("Receiver", 0);
        serverLabel.reshape(width - 8 * widthU, heightU, 7 * widthU, heightU);
        serverLabel.hide();
        add(serverLabel);
        demoButton = new Button("See a demo");
        demoButton.reshape(width / 2 + widthU, height - 7 * heightU, 7 * widthU, heightU);
        demoButton.disable();
        add(demoButton);
        startButton = new Button("Try sending mail by yourself");
        startButton.reshape(width / 2 - widthU * 8, height - 7 * heightU, 7 * widthU, heightU);
        startButton.disable();
        add(startButton);
        addressLabel = new Label("Enter the Sender domain name :");
        addressLabel.reshape(width / 2 - widthU * 5, heightU * 7, 10 * widthU, heightU);
        add(addressLabel);
        addressButton = new Button("OK");
        addressButton.reshape(width / 2 - widthU * 2, heightU * 10, 4 * widthU, heightU);
        add(addressButton);
        addressTextField = new TextField(64);
        addressTextField.reshape(width / 2 - widthU * 5, heightU * 8, 10 * widthU, heightU);
        addressTextField.setText("YAHOO.COM");
        add(addressTextField);
        addressTextField.requestFocus();
        connectionLabel = new Label("the TCP connection is the base channel of the SMTP protocol", 1);
        connectionLabel.reshape(0, heightU * 11 + heightU / 2, width, heightU);
        connectionLabel.hide();
        add(connectionLabel);
    }

    public void destroy()
    {
    }

    public void paint(Graphics g)
    {
        if(!painted)
        {
            painted = true;
            graph = g.create(3 * widthU + widthU / 2, 10 * heightU, width - 7 * widthU, heightU);
            graphics = g.create();
        }
        if(clientVisible)
            g.drawRect(widthU / 2, heightU / 2, 8 * widthU, 4 * heightU);
        if(serverVisible)
            g.drawRect(width - widthU / 2 - 8 * widthU, heightU / 2, 8 * widthU, 9 * heightU);
        if(connected)
        {
            g.drawLine(widthU / 2 + widthU * 2, 4 * heightU + heightU / 2, widthU / 2 + widthU * 2, 11 * heightU);
            g.drawLine(width - widthU / 2 - widthU * 2, 9 * heightU + heightU / 2, width - widthU / 2 - widthU * 2, 11 * heightU);
            g.drawLine(widthU / 2 + widthU * 2, 11 * heightU, width - widthU / 2 - widthU * 2, 11 * heightU);
        }
    }

    private synchronized void paintSelf()
    {
        if(connected)
        {
            graphics.drawLine(widthU / 2 + widthU * 2, 4 * heightU + heightU / 2, widthU / 2 + widthU * 2, 11 * heightU);
            graphics.drawLine(width - widthU / 2 - widthU * 2, 9 * heightU + heightU / 2, width - widthU / 2 - widthU * 2, 11 * heightU);
            graphics.drawLine(widthU / 2 + widthU * 2, 11 * heightU, width - widthU / 2 - widthU * 2, 11 * heightU);
        }
        if(clientVisible)
            graphics.drawRect(widthU / 2, heightU / 2, 8 * widthU, 4 * heightU);
        if(serverVisible)
            graphics.drawRect(width - widthU / 2 - 8 * widthU, heightU / 2, 8 * widthU, 9 * heightU);
        repaint();
    }

    private void enableActions()
    {
        clientSend.show();
        clientText.setEditable(true);
    }

    private void disableActions()
    {
        clientSend.hide();
        clientText.setEditable(false);
    }

    private void showServer()
    {
        serverVisible = true;
        mailMsg.show();
        usersLabel.show();
        serverLabel.show();
        paintSelf();
    }

    private void hideServer()
    {
        serverVisible = false;
        mailMsg.hide();
        usersLabel.hide();
        serverLabel.hide();
        paintSelf();
    }

    private void showClient()
    {
        clientVisible = true;
        clientText.show();
        clientLabel.show();
        paintSelf();
    }

    private void hideClient()
    {
        clientVisible = false;
        clientText.hide();
        clientLabel.hide();
        paintSelf();
    }

    private void simulateCmd(String s)
    {
        Event event = new Event(clientText, 1001, null);
        clientText.setText(s);
        try
        {
            Thread.currentThread();
            Thread.sleep(500L);
        }
        catch(InterruptedException interruptedexception) { }
        deliverEvent(event);
    }

    public boolean action(Event event, Object obj)
    {
        if(event.target == demoButton && event.id == 1001)
        {
            log.setText("");
            startButton.disable();
            demoButton.disable();
            connected = true;
            paintSelf();
            connectionLabel.show();
            String s;
            moveMessage(s = server.establishConnection(), reply);
            log.appendText("Receiver :" + s + "\n");
            simulateCmd("HELO " + client.getAddress());
            simulateCmd("VRFY amar");
            simulateCmd("VRFY VENKAT");
            simulateCmd("MAIL FROM:ALLA BAKSHU@" + client.getAddress());
            simulateCmd("RCPT TO:VENKAT@" + server.getAddress());
            simulateCmd("DATA");
            simulateCmd("Hi,");
            simulateCmd("     Now transfering the mail message,");
            simulateCmd("     these lines do not reuire the acknowlegement of the receiver");
            simulateCmd("     until the .<CRLF> command is sent.");
            simulateCmd(".");
            simulateCmd("QUIT");
            startButton.enable();
            demoButton.enable();
        } else
        if(event.target == startButton && event.id == 1001)
        {
            if(!connected)
            {
                log.setText("");
                demoButton.disable();
                startButton.setLabel("Abort (disconnect)");
                connected = true;
                paintSelf();
                connectionLabel.show();
                enableActions();
                String s1;
                moveMessage(s1 = server.establishConnection(), reply);
                log.appendText("Receiver :" + s1 + "\n");
            } else
            {
                disableActions();
                connected = false;
                paintSelf();
                startButton.setLabel("Try sending mail by yourself");
                demoButton.enable();
                connectionLabel.hide();
            }
        } else
        if((event.target == clientSend || event.target == clientText) && event.id == 1001)
        {
            String s2 = clientText.getText() + "<CRLF>";
            clientText.setText("");
            moveMessage(s2, cmd);
            log.appendText("Sender :" + s2 + "\n");
            s2 = server.receive(s2);
            if(s2 != null)
            {
                moveMessage(s2, reply);
                log.appendText("Receiver :" + s2 + "\n");
                s2 = client.receive(s2);
                if(s2 != null && s2.compareTo("TERMINATE") == 0)
                {
                    disableActions();
                    connected = false;
                    paintSelf();
                    connectionLabel.hide();
                    startButton.enable();
                    demoButton.enable();
                }
            }
        } else
        if((event.target == addressButton || event.target == addressTextField) && event.id == 1001)
        {
            addresses++;
            if(addresses == 1)
            {
                client = new smtpcs(addressTextField.getText(), 1, null);
                clientLabel.setText(clientLabel.getText() + " : " + addressTextField.getText());
                addressLabel.setText("Enter the Receiver domain name :");
                addressTextField.setText("hotmail.com");
                addressTextField.requestFocus();
                showClient();
            } else
            {
                server = new smtpcs(addressTextField.getText(), 2, mailMsg);
                serverLabel.setText(serverLabel.getText() + " : " + addressTextField.getText());
                server.addUser("VENKAT");
                server.addUser("ALLA BAKSHU");
                server.addUser("NAGAIAH");
                server.addUser("GANGA");
                showServer();
                addressButton.hide();
                addressTextField.hide();
                addressLabel.hide();
                log.enable();
                clientText.enable();
                startButton.enable();
                demoButton.enable();
            }
        }
        return true;
    }


class smtpcs
{

    public smtpcs(String s, int i, TextArea textarea)
    {
        cs = i;
        waiting = false;
        available = true;
        address = s;
        state = 0;
        outputArea = textarea;
        userList = new Vector();
    }

    private boolean checkAddress(String s)
    {
        return true;
    }

    private String userName(String s)
    {
        int i = s.indexOf('@');
        if(i > 0)
            return s.substring(0, i);
        else
            return s;
    }

    private int getCmd(String s)
    {
        if(s.length() >= 4)
        {
            String s1 = s.toUpperCase();
            if(s1.startsWith("HELO"))
                return 1;
            if(s1.startsWith("MAIL"))
                return 2;
            if(s1.startsWith("RCPT"))
                return 3;
            if(s1.startsWith("DATA"))
                return 4;
            if(s1.startsWith("RSET"))
                return 7;
            if(s1.startsWith("NOOP"))
                return 51;
            if(s1.startsWith("QUIT"))
                return 6;
            if(s1.startsWith("VRFY"))
                return 54;
            if(s1.startsWith(".<CRLF>"))
                return 5;
            if(s1.startsWith("221 "))
                return 1000;
        }
        return 0;
    }

    private int breakCmd(String s)
    {
        int i = getCmd(s);
        if(i != 0)
        {
            if(i == 2)
                arg = s.substring(10, s.length() - 6);
            else
            if(i == 3)
                arg = s.substring(8, s.length() - 6);
            else
                arg = s.substring(5, s.length() - 6);
        } else
        if(s.startsWith(".."))
            arg = s.substring(1, s.length() - 6);
        else
            arg = s.substring(0, s.length() - 6);
        arg.trim();
        return i;
    }

    public String receive(String s)
    {
        int i = breakCmd(s);
        if(cs == 2)
            switch(i)
            {
            case 1: // '\001'
                if(state == 1)
                {
                    if(!checkAddress(arg))
                    {
                        return "501 Address is not valid : " + arg + " <CRLF>";
                    } else
                    {
                        state = 2;
                        otherSide = arg;
                        return "250 " + address;
                    }
                } else
                {
                    return "503 HELO is not a valid command in this stage of the session <CRLF>";
                }

            case 2: // '\002'
                if(state == 2)
                {
                    state = 3;
                    sender = arg;
                    if(outputArea != null)
                    {
                        outputArea.setText("");
                        outputArea.replaceText("From : " + arg + "\n", fromPos, dataPos);
                        dataPos = fromPos + arg.length() + 8;
                    }
                    return "250 OK <CRLF>";
                } else
                {
                    return "500 MAIL is not a valid command in this stage of the session <CRLF>";
                }

            case 3: // '\003'
                if(state == 3 || state == 4)
                {
                    state = 4;
                    if(userList.contains(userName(arg)))
                        return "250 OK <CRLF>";
                    else
                        return "550 No such user here <CRLF>";
                } else
                {
                    return "503 RCPT is not a valid command in this stage of the session <CRLF>";
                }

            case 4: // '\004'
                if(state == 4)
                {
                    state = 5;
                    return "354 Start mail input end with .<CRLF>";
                } else
                {
                    return "503 DATA is not a valid command in this stage of the session <CRLF>";
                }

            case 5: // '\005'
                if(state == 5)
                {
                    state = 2;
                    return "250 OK <CRLF>";
                } else
                {
                    return "503 \".\" is not a valid command in this stage of the session <CRLF>";
                }

            case 6: // '\006'
                if(state == 2)
                {
                    state = 0;
                    return "221 " + address + " Service closing transmission channel <CRLF>";
                } else
                {
                    return "503 QUIT must be the last command in the session <CRLF>";
                }

            case 7: // '\007'
                state = 2;
                fromPos = 0;
                dataPos = 0;
                outputArea.setText("");
                return "250 OK <CRLF>";

            case 51: // '3'
                return "250 OK <CRLF>";

            case 52: // '4'
                return "250 HELP is not currently suported <CRLF>";

            case 53: // '5'
                return "250 OK <CRLF>";

            case 54: // '6'
                if(userList.contains(userName(arg)))
                    return "250 OK <CRLF>";
                else
                    return "550 No such user here \"" + arg + "\" <CRLF>";

            case 0: // '\0'
                if(state != 5)
                {
                    return "500 Unknown command <CRLF>";
                } else
                {
                    outputArea.appendText(arg + "\n");
                    return null;
                }
            }
        else
        if(cs == 1 && i == 1000)
            return "TERMINATE";
        return null;
    }

    public boolean addUser(String s)
    {
        if(!userList.contains(s))
        {
            userList.addElement(s);
            return true;
        } else
        {
            return false;
        }
    }

    public String establishConnection()
    {
        if(available)
        {
            state = 1;
            return "220 " + address + " Simple Mail Transfer Protocol Ready <CRLF>";
        } else
        {
            return "421 Not available <CRLF>";
        }
    }

    public String getAddress()
    {
        return address;
    }

    public static final int SENDER = 1;
    public static final int RECEIVER = 2;
    final int NOT_CONNECTED = 0;
    final int CONNECTION_ESTABLISHED = 1;
    final int SESSION_START = 2;
    final int MAIL_SESSION = 3;
    final int RECIPIENT = 4;
    final int DATA_TRANSFER = 5;
    final int MAIL_END = 2;
    final int SESSION_END = 0;
    final int NOT_CMD = 0;
    final int HELO = 1;
    final int MAIL = 2;
    final int RCPT = 3;
    final int DATA = 4;
    final int END_DATA = 5;
    final int QUIT = 6;
    final int RSET = 7;
    final int NOOP = 51;
    final int HELP = 52;
    final int EXPN = 53;
    final int VRFY = 54;
    final int TERMINATE = 1000;
    final String OK = "250 OK <CRLF>";
    private String address;
    private String otherSide;
    private String sender;
    private String arg;
    private int cs;
    private int state;
    boolean waiting;
    boolean available;
    private Vector userList;
    private int fromPos;
    private int dataPos;
    private TextArea outputArea;
}

    public void start()
    {
    }

    public void stop()
    {
        graph.dispose();
        graphics.dispose();
    }

    private synchronized void moveMessage(String s, int i)
    {
        java.awt.Color color = getForeground();
        java.awt.Color color1 = getBackground();
        int j = graph.getClipRect().width;
        int k = graph.getClipRect().height;
        int l = getFontMetrics(getFont()).stringWidth(s);
        if(i == 0)
        {
            for(int i1 = -l; i1 < j + 8; i1 += 2)
            {
                graph.setColor(color1);
                graph.fillRect(0, 0, j, k);
                graph.setColor(color);
                graph.drawString(s, i1, k / 2);
                try
                {
                    Thread.currentThread();
                    Thread.sleep(10L);
                }
                catch(InterruptedException interruptedexception) { }
            }

            return;
        }
        for(int j1 = j; j1 > -l - 8; j1 -= 2)
        {
            graph.setColor(color1);
            graph.fillRect(0, 0, j, k);
            graph.setColor(color);
            graph.drawString(s, j1, k / 2);
            try
            {
                Thread.currentThread();
                Thread.sleep(10L);
            }
            catch(InterruptedException interruptedexception1) { }
        }

    }

    private int height;
    private int width;
    private int widthU;
    private int heightU;
    private TextArea log;
    private TextArea mailMsg;
    private Label message;
    private Label clientLabel;
    private Label serverLabel;
    private Label logLabel;
    private Label connectionLabel;
    private Label usersLabel;
    private TextField clientText;
    private Button clientSend;
    private Button startButton;
    private Button demoButton;
    private boolean connected;
    private boolean painted;
    private boolean serverVisible;
    private boolean clientVisible;
    private int addresses;
    private int reply;
    private int cmd;
    private smtpcs client;
    private smtpcs server;
    private Graphics graph;
    private Graphics graphics;
    private Button addressButton;
    private TextField addressTextField;
    private Label addressLabel;
}
